//Scrivere un programma C che legge da tastiera una matrice di 4x2 
//elementi float e ne stampa la versione trasposta; scrivere la 
//funzione che prende una matrice e ne genera la trasposta.
//
//SUGGERIMENTO: la trasposta di una matrice A 4x2 e' 
//una matrice B 2x4 avente a(i,j)=b(j,i)

#include <stdio.h>

#define N 4
#define M 2

void trasponi(float sorg[][M], float dest[][N],  int righesorg, int colonnesorg);


int main(int argc, char *argv[])
{
  int i,j;
  float A[N][M];
  float B[M][N];


  for(i=0; i<N; i++)
  {
    for(j=0; j<M; j++)
    {
      printf("\nElem (%d, %d):  ", i, j);
      scanf("%f", &A[i][j]);
    }
  }

  trasponi(A, B, N, M);

  printf("\n\nMatrice sorgente:\n\n");

  for(i=0; i<N; i++)
  {
    for(j=0; j<M; j++)
    {
      printf("%f ", A[i][j]);
    }
    printf("\n");
  }

  printf("\n\nMatrice destinazione:\n\n");

  for(i=0; i<M; i++)
  {
    for(j=0; j<N; j++)
    {
      printf("%f ", B[i][j]);
    }
    printf("\n");
  }

  return 0;
}

void trasponi(float sorg[][M], float dest[][N],  int righesorg, int colonnesorg)
{
  int i, j;

  for(i=0; i<righesorg; i++)
  {
      for(j=0; j<colonnesorg; j++)
      {
        dest[j][i] = sorg[i][j];
      }
  }
}


