//Scrivere un programma C che legge da tastiera una matrice di NxM 
//elementi float e ne stampa la versione trasposta; scrivere la 
//funzione che prende una matrice e ne genera la trasposta.
//N e M sono introdotti da tastiera
//
//SUGGERIMENTO: la trasposta di una matrice A NxM e' 
//una matrice B MxN avente a(i,j)=b(j,i)

#include <stdio.h>
#include <stdlib.h>

void trasponi(float *sorg, float *dest,  int righesorg, int colonnesorg);

int main(int argc, char *argv[])
{
  int i,j,n,m;
  float *A,*B;

  printf("\nInserire N:\n");
  scanf("%d", &n);
  printf("\nInserire M:\n");
  scanf("%d", &m);

  A=(float*)malloc(sizeof(float)*n*m);
  B=(float*)malloc(sizeof(float)*m*n);

  for(i=0; i<n; i++)
  {
    for(j=0; j<m; j++)
    {
      printf("\nElem (%d, %d):  ", i, j);
      scanf("%f", &A[i*m+j]);
    }
  }

  trasponi(A, B, n, m);

  printf("\n\nMatrice sorgente:\n\n");

  for(i=0; i<n; i++)
  {
    for(j=0; j<m; j++)
    {
      printf("%f ", A[i*m+j]);
    }
    printf("\n");
  }

  printf("\n\nMatrice destinazione:\n\n");

  for(i=0; i<m; i++)
  {
    for(j=0; j<n; j++)
    {
      printf("%f ", B[i*n+j]);
    }
    printf("\n");
  }

  free(A);
  free(B);

  return 0;
}

void trasponi(float *sorg, float *dest,  int righesorg, int colonnesorg)
{
  int i, j;

  for(i=0; i<righesorg; i++)
  {
      for(j=0; j<colonnesorg; j++)
      {
        dest[j*righesorg+i] = sorg[i*colonnesorg+j];
      }
  }
}


